---
title: MessageChannel.port2
slug: Web/API/MessageChannel/port2
tags:
  - API
  - Channel messaging
  - HTML5
  - MessageChannel
  - Property
  - Reference
  - port2
---
<p>{{APIRef("HTML DOM")}}</p>

<p>The <code><strong>port2</strong></code> read-only property of the {{domxref("MessageChannel")}} interface returns the second port of the message channel — the port attached to the context at the other end of the channel, which the message is initially sent to.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">channel.port2;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("MessagePort")}} object representing the second port of the channel, the port attached to the context at the other end of the channel.</p>

<h2 id="Example">Example</h2>

<p>In the following code block, you can see a new channel being created using the {{domxref("MessageChannel()", "MessageChannel.MessageChannel")}} constructor. When the IFrame has loaded, we pass <code>port2</code> to the IFrame using {{domxref("MessagePort.postMessage")}} along with a message. The <code>handleMessage</code> handler then responds to a message being sent back from the IFrame (using {{domxref("MessagePort.onmessage")}}), putting it into a paragraph. {{domxref("MessageChannel.port1")}} is listened to, to check when the message arrives.</p>

<pre class="brush: js">var channel = new MessageChannel();
var para = document.querySelector('p');

var ifr = document.querySelector('iframe');
var otherWindow = ifr.contentWindow;

ifr.addEventListener("load", iframeLoaded, false);

function iframeLoaded() {
  otherWindow.postMessage('Hello from the main page!', '*', [channel.port2]);
}

channel.port1.onmessage = handleMessage;
function handleMessage(e) {
  para.innerHTML = e.data;
}   </pre>

<p>For a full working example, see our <a class="external external-icon" href="https://github.com/mdn/dom-examples/tree/master/channel-messaging-basic">channel messaging basic demo</a> on Github (<a class="external external-icon" href="https://mdn.github.io/dom-examples/channel-messaging-basic/">run it live too</a>).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'web-messaging.html#dom-messagechannel-port2', 'port2')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MessageChannel.port2")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API/Using_channel_messaging">Using channel messaging</a></li>
</ul>
